##parameters=level=None, base=None, show_docs=None, base_path='/', max_results=None, context_rurl=None, **kw

REQUEST=context.REQUEST

if level is None:
   return

if show_docs is None:
   show_docs = 0
else:
   try:
      show_docs=int(show_docs)
   except:
      show_docs = 0

try:
   level = int(level)
except:
   return

utool = context.portal_url
mtool = context.portal_membership
wtool = context.portal_workflow
portal_url = utool(relative=1) 
if portal_url != '/':
    portal_url = '/' + portal_url

current_obj = None
if context_rurl is not None:
    current_path = context_rurl
else:
    current_obj = REQUEST.get('context_obj', None)
    if current_obj is not None:
        current_path = '/' + utool.getRelativeUrl(current_obj)
    else:
        return

if current_obj is None:
    current_obj = context.restrictedTraverse(portal_url + current_path)

here_url = current_obj.absolute_url()

if not base_path.startswith('/'):
    base_path = '/' + base_path

base_url = portal_url
if base_path != '/':
    base_url += base_path

try:
    # restrictedTraverse() raises IndexError if the url starts with '/' (??)
    # a problem here is that the url may start with '//' if portal_url is '/'
    if len(base_path) > 1:
       # instead of base_path = lstrip('/') 
       # to ensure compatibility with python 2.1
       i = 0
       while base_path[i] == '/':
           base_path = base_path[1:]
    base_obj = context.restrictedTraverse(base_path)
except (KeyError,'NotFound','Unauthorized'):
    return

if not current_path.startswith(base_path):
    if level > 0:
        return 
    else:
        level_obj = base_obj
else:
    split_current_path = current_path.split('/')
    if not getattr(current_obj.aq_explicit, 'isPrincipiaFolderish', 0):
        split_current_path = split_current_path[0:len(split_current_path)-1]
    split_base_path = base_path.split('/')
    split_relative_path = split_current_path[0:len(split_base_path)+level-1]

    if split_relative_path == ['']:
        level_obj = utool
    else:
        relative_path = '/'.join(split_relative_path) 

        try:
            pp = portal_url + relative_path
            if len(pp) > 1:
                # instead of pp = lstrip('/') 
                # to ensure compatibility with python 2.1
                i = 0
                while pp[i] == '/':
                    pp = pp[1:]
            level_obj = context.restrictedTraverse(pp)
        except (KeyError, 'Unauthorized'):
            return

    if len(split_relative_path) <= level:
        return 

dict = {}
obj_info = []
create_url = ''
folder_title = level_obj.Title()

if mtool.checkPermission('Add portal content', level_obj):
    create_url = level_obj.absolute_url() + '/folder_factories'

objs = level_obj.contentValues()
if max_results is not None:
    objs = level_obj.contentValues()[0:max_results]

# (nicked the publishing check from plone's StatelessTree.py:checkPublished)
# XXX Should also look up the roles that sees unpublished content
rolesSeeUnpublishedContent = ['Manager','Reviewer','Owner']
user = mtool.getAuthenticatedMember()
now = DateTime()

user_has_role = user.has_role
for obj in objs:
    folderish = getattr(obj.aq_explicit, 'isPrincipiaFolderish', 0)
    if not folderish and not show_docs: 
        continue

    if not user_has_role(rolesSeeUnpublishedContent, obj):
        if wtool.getInfoFor(obj,'review_state','') != 'published':
            continue
       
        start_pub = getattr(obj, 'effective_date', None)
        end_pub   = getattr(obj, 'expiration_date', None)
        if start_pub and start_pub > now:
            continue
        if end_pub and now > end_pub:
            continue

    obj_url = obj.absolute_url()
    obj_info.append(
        {'id':  obj.getId(),
         'title': obj.title_or_id(),
         'url': obj_url,
         'selected': (here_url + '/').startswith(obj_url + '/'),
         'icon': obj.getIcon(),
         'folderish': folderish,
        }
    ) 

return { 'menuentries': obj_info,
         'create_url': create_url,
         'folder_title': folder_title }

